;|=================================================[  UhspDraw.as       ]=====|
#ifndef        __UHSP_DRAW__
#define global __UHSP_DRAW__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Draw
#deffunc  Draw_PalLoad str p1,int p2,local ii,local jj,local rr
          exist  p1 :if (strsize  <  $436) {return -1}:dim ii,270 :bload p1,ii,$436
                     if (peek(ii,$1c) > 8) {return -1}:if (wpeek(ii,0) != $4d42) {return -1}
                 rr =   lpeek(ii,$2e)                 :if (rr == 0) {rr = 256}    :jj = $36
          repeat rr :palette cnt,peek(ii,jj+2),peek(ii,jj+1),peek(ii,jj),cnt=rr-1 :jj+= 4 :loop
          picload p1,p2
return   _MakeLong(lpeek(ii,$12),lpeek(ii,$16))
;|========.===========================.============[                    ]=====|
#deffunc  Draw_Paint int p1,int p2,int p3,int p4,int p5,local ii,local jj
                            mref _Hbms@Func,67
          if (p3 == _NULL) {jj = _Hbms@Func(40)} else {jj     =  p3}
          __GetPixel        hdc,p1,p2                 :ii(0)  =  p4,jj,p5,stat
          if (ii(3) == -1) {return}
          __CreateBrushIndirect varptr(ii)            :ii(0)  =  stat
          __SelectObject    hdc,ii(0)                 :ii(1)  =  stat
          __ExtFloodFill    hdc,p1,p2,ii(3),1         :ii(2)  =  stat
          if (ii(2) !=  1) {__ExtFloodFill hdc,p1,p2,ii(3)}
          __SelectObject    hdc,ii(1)                 :__DeleteObject ii :__ReleaseDC hwnd,hdc :_ChkDraw
return
#deffunc  Draw_Polygon int p1,int p2,int p3,int p4,double p5,int p6,int p7,local ii,local jj,local nn
          if (p7    != -1) {Func_Color ,,,p7}
          repeat abs(p3)
                 nn(0)  =  deg2rad((360.0/p3)*(cnt+1))+deg2rad(p5)+(m_pi/2),deg2rad((360.0/p3)* cnt)+deg2rad(p5)+(m_pi/2)
                 ii     =  p1+(cos(nn(0))*p4),p1+(cos(nn(1))*p4),p1,p1
                 jj     =  p2-(sin(nn(0))*p4),p2-(sin(nn(1))*p4),p2,p2
               if (p6)    {                     gsquare -1,ii,jj}
             else         {Func_Bswap -3,_BCLP :gsquare -1,ii,jj :Func_Bswap -1    :line ii,jj,ii(1),jj(1)}
          loop
return
#deffunc  Draw_ArcRa int p1,int p2,int p3,int p4,int p5,int p6,local ii,local jj
          if (p6    != -1) {Func_Color ,,,p6}
          ii    =  p1+int(cos(deg2rad(p4))*p3) :jj =  p2-int(sin(deg2rad(p4))*p3)  :pos ii,jj :mref _Hbms@Func,67
          __SelectObject  hdc,_Hbms@Func(36)   :__SelectObject hdc,_Hbms@Func(37)
              __MoveToEx  hdc,ii,jj,0          :    __AngleArc hdc,p1,p2,p3,p4,p5-p4
          ii    =  p1+int(cos(deg2rad(p5))*p3) :jj =  p2-int(sin(deg2rad(p5))*p3)  :_ChkDraw
return   _MakeLong(jj,ii)
#deffunc  Draw_Line int p1,int p2,int p3,int p4,int p5,int p6,local ii
          if (p6    != -1) {Func_Color ,,,p6}
          if (p5    ==  1) {line p1,p2,p3,p2   :line p1,p4 :line p3,p4       :line p3,p2}
     else:if (p5    ==  2) {line p1,p2,p3,p2   :line p1,p4 :line p3,p4       :line p3,p2       :boxf p1+1,p2+1,p3-1,p4-1}
     else:if (p5    ==  3) {line p1-p3,p2-p4,p1+p3,p2-p4   :line p1-p3,p2+p4 :line p1+p3,p2+p4 :line p1+p3,p2-p4}
     else:if (p5    ==  4) {line p1-p3,p2-p4,p1+p3,p2-p4   :line p1-p3,p2+p4 :line p1+p3,p2+p4 :line p1+p3,p2-p4
                           :boxf p1-p3+1,p2-p4+1,p1+p3-1,p2+p4-1}
     else:if (p5    ==  5) {ii     = int(_Round(cos(deg2rad(-p4))*p3+p1))    ,int(_Round(sin(deg2rad(-p4))*p3+p2))         :line ii,ii(1),p1,p2}
     else:if (p5    ==  6) {line p1+p3,p2,p1-p3,p2         :line p1,p2+p4,p1,p2-p4}
     else                  {if (p3 == -1) and (p4 == -1)   {line p1,p2} else {line p1,p2,p3,p4}}
return
#deffunc  Draw_Circle int p1,int p2,int p3,int p4,int p5,int p6,local ii
          if (p6    != -1) {Func_Color ,,,p6}
          if (p5    ==  0) or  (p5 ==  1) {circle p1,p2,p3,p4,p5}
     else:if (p5    ==  2) or  (p5 ==  3) {if (p4 == -1) {ii = (p3/sqrt(2.0)),ii} else {ii = (p3/sqrt(2.0)),p4/sqrt(2.0)}  :circle p1-ii,p2-ii(1),p1+ii,p2+ii(1),p5-2}
     else                                 {circle p1,p2,p3,p4,0}
return
#deffunc  Draw_Boxf int p1,int p2,int p3,int p4,int p5,int p6,int p7
          if (p5    != -1) {if (p6 != -1) {gradf p1,p2,p3-p1,p4-p2,p7,p5,p6}      else {Func_Color ,,,p5 :boxf p1,p2,p3,p4 :Func_Color ,,,16}}
     else                  {boxf p1,p2,p3,p4}
return
#deffunc  Draw_Arrow int p1,int p2,int p3,int p4,int p5,double p6,int p7,int p8,local nn,local ii
          if (p8    != -1) {Func_Color ,,,p8}
          nn    =  rad2deg(atan(p4-p2,p3-p1)*-1),deg2rad(-nn-(180.0-p6)),deg2rad(-nn+(180.0-p6))
          ii    =  int(_Round(cos(nn(1))*p5+p3)),int(_Round(sin(nn(1))*p5+p4)),int(_Round(cos(nn(2))*p5+p3)),int(_Round(sin(nn(2))*p5+p4)),int(_Round(cos(deg2rad(p6))*p5))
                            line p3,p4,ii(0),ii(1)         :line p3,p4,ii(2),ii(3)
          if (p7         ) {line ii(0),ii(1),ii(2),ii(3)   :line p1,p2,int(_Round(p3-cos(deg2rad(-nn))*ii(4))),int(_Round(p4-sin(deg2rad(-nn))*ii(4)))} else {line p1,p2,p3,p4}
return
;|========.===========================.============[                    ]=====|
#define global       _Line(%1=0,%2=0,%3=-1,%4=-1,%5=0,%6=-1)                             Draw_Line    %1,%2,%3,%4,%5,%6
#define global       _Circle(%1=0,%2=0,%3=0,%4=-1,%5=1,%6=-1)                            Draw_Circle  %1,%2,%3,%4,%5,%6
#define global       _Boxf(%1=0,%2=0,%3=ginfo_sx,%4=ginfo_sy,%5=-1,%6=-1,%7=1)           Draw_Boxf    %1,%2,%3,%4,%5,%6,%7
#define global       _Arrow(%1=0,%2=0,%3=ginfo_cx,%4=ginfo_cy,%5=30,%6=15.0,%7=0,%8=-1)  Draw_Arrow   %1,%2,%3,%4,%5,%6,%7,%8
#define global       _PalLoad(%1="",%2=0)                                                Draw_PalLoad %1,%2
#define global       _Paint(%1=0,%2=0,%3=_NULL,%4=0,%5=0)                                Draw_Paint   %1,%2,%3,%4,%5
#define global       _Polygon(%1=0,%2=0,%3=6,%4=50,%5=0.0,%6=0,%7=-1)                    Draw_Polygon %1,%2,%3,%4,%5,%6,%7
#define global       _Arc(%1=0,%2=0,%3=50,%4=270,%5=360,%6=-1)                           Draw_ArcRa   %1,%2,%3,%4,%5,%6
;|========.===========================.============[                    ]=====|
#define global       _Pdup(%1=_Ures@Func)                mref %1,66
#define global ctype _Pget(%1=0,%2=0,%3=_Ures@Func) _Rgb(peek(%3,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)+2),peek(%3,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)+1),peek(%3,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)))
#define global       _Pset(%1=0,%2=0,%3=0,%4=_Ures@Func) poke %4,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)+2,_Bgr(%3,0) :\
                                                         poke %4,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)+1,_Bgr(%3,1) :\
                                                         poke %4,(((%1)+((ginfo_winy-1)-(%2))*ginfo_winx)*3)  ,_Bgr(%3,2)
;|============================================================================|
#global
#endif
