;|=================================================[  UhspOpto.as       ]=====|
#ifndef        __UHSP_OPTO__
#define global __UHSP_OPTO__
;|========.===========================.============[                    ]=====|
#uselib  "winmm.dll"
#func   global __midiOutOpen               "midiOutOpen"             sptr,sptr,sptr,sptr,sptr
#func   global __midiOutSetVolume          "midiOutSetVolume"        sptr,sptr
#func   global __midiOutShortMsg           "midiOutShortMsg"         sptr,sptr
#uselib  "psapi.dll"
#func   global __EnumProcesses             "EnumProcesses"           sptr,sptr,sptr
#func   global __EnumProcessModules        "EnumProcessModules"      sptr,sptr,sptr,sptr
#func   global __GetModuleBaseName         "GetModuleBaseNameA"      sptr,sptr,sptr,sptr
#func   global __GetModuleFileNameEx       "GetModuleFileNameExA"    sptr,sptr,sptr,sptr
#func   global __GetProcessMemoryInfo      "GetProcessMemoryInfo"    sptr,sptr,sptr
;|========.===========================.============[                    ]=====|
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Opto
#defcfunc Opto_Julius int p1,int p2,int p3,int p4,int p5,int p6,int p7,local ii,local jj,local rr
              ii(0) = p1,p2,p3,p4,p5,p6,p7,0
          if (ii(0) == -1) {ii(0) = 0+gettime(0)} :if (ii(1) == -1) {ii(1) = 0+gettime(1)}
          if (ii(2) == -1) {ii(2) = 0+gettime(3)} :if (ii(3) == -1) {ii(3) = 0+gettime(4)}
          if (ii(4) == -1) {ii(4) = 0+gettime(5)} :if (ii(5) == -1) {ii(5) = 0+gettime(6)}
          if (ii(6) == -1) {ii(6) = 0+gettime(7)} :if (ii(1) <=  2) {ii(0)-- :ii(1) += 12}
              jj     = (1.0*ii(6))      / 1000    :jj     = (jj+ii(5)) / 60
              jj     = (jj+ii(4)+ii(7)) /   60    :jj     = (jj+ii(3)) / 24
              rr     =  1.0*int(365.25*ii(0))+int(1.0*ii(0)/400)-int(1.0*ii(0)/100)
              rr    +=  jj+int(30.59*(ii(1)-2))+ii(2)-678912+2400000.5
return  rr
#defcfunc Opto_Gregorio double p1,local nn,local rr,local ss
              nn(0)  =  p1   ,nn(0)+0.5-_Floor(nn(0)+0.5)                  :nn(0)  = _Floor(nn(0)+0.5)
              nn(2)  = _Floor(_Floor((nn(0)-4479.5)/36524.25)*0.75+0.5)-37 :nn(2)  =  nn(0)+nn(2)*1
              rr(0)  = _Floor(nn(2)/365.25)-4712                           :nn(3)  =  nn(2)-59.25
              nn(3)  = _Floor(nn(3)-_Floor(nn(3)/365.25)*365.25)+0.5       :nn(4)  = _Floor(nn(3)/30.6)+2
              rr(1)  =  nn(4)-_Floor(nn(4)/12)*12+1                        :rr(2)  = _Floor(nn(3)-_Floor(nn(3)/30.6)*30.6+1)
              rr(3)  = _Floor(nn(1)*24)                                    :rr(4)  = _Floor((nn(1)*24-_Floor(nn(1)*24))*60)
              rr(5)  = _Round(nn(1)*24*60*60-_Floor(nn(1)*24)*60*60-_Floor((nn(1)*24-_Floor(nn(1)*24))*60)*60)
              ss     =  "" :repeat 6 :ss+= strf("%02d",rr(cnt))+","  :loop :ss+= "00"
return  ss
;|========.===========================.============[                    ]=====|
#deffunc  Opto_Midi int p1,int p2,int p3,int p4,int p5
          if (p1    >=  0) {             ;  volmax=65535
              if (_hMid@Func(p5) ==   0) {__midiOutOpen varptr(_hMid@Func(p5)),0,0,0,0}
                                          __midiOutShortMsg    _hMid@Func(p5),($C0 | p3<<8 |  0<<16)
                                          __midiOutShortMsg    _hMid@Func(p5),($90 | p1<<8 | p4<<16)
                              wait p2+1  :__midiOutShortMsg    _hMid@Func(p5),($80 | p1<<8 | p4<<16)}
        else {if ( p1            ==  -1) {__midiOutClose       _hMid@Func(p5) :_hMid@Func(p5) = 0 :return}
              if ( p1            ==  -2) {__midiOutSetVolume   _hMid@Func(p5), _MakeLong(p2,p2)   :return}}
return
;|========.===========================.============[                    ]=====|
#defcfunc Opto_GetHwnd array p1,int p2,int p3,local ii,local rr
   repeat :__FindWindowExA p2,ii,0,0 :        ii =  stat :if (ii   == 0) {break   }
          if (p3)          {__IsWindowVisible ii         :if (stat == 0) {continue}} :p1(rr) = ii :rr++ :loop
return  rr
#defcfunc Opto_GetName int p1,int p2,local nn,local rr
          if (p2)          {nn(0) = p1}
        else               {__GetWindowLongA p1,-6                            :nn(1) = stat
                            __GetWindowThreadProcessId p1,varptr(nn(0))       :nn(2) = stat}
                            __OpenProcess  $411,0,nn(0)                       :nn(3) = stat
          if (p2)          {__EnumProcessModules  nn(3),varptr(nn(1)),4,varptr(nn(2))}
          if (nn(3) ==  0) {  return ""}                 :      sdim rr ,512
                            __GetModuleFileNameEx nn(3),nn(1),varptr(rr),512
                            __CloseHandle         nn(3)  :if(strlen@hsp(rr)<3){rr    = ""}
return  rr
#defcfunc Opto_GetProcess array p1,int p2,local ii,local jj,local nn,local rr
                 dim nn,p2 :__EnumProcesses varptr(nn),p2,varptr(jj)
              repeat jj/4  :__OpenProcess $411,0,nn(cnt) : ii = stat
                 if (ii)   {__EnumProcessModules ii,varptr(ii(1)),4,varptr(ii(2))
                 if (stat) {  p1(rr) = nn(cnt)  :rr++}}  :__CloseHandle ii
              loop
return  rr
#defcfunc Opto_GetPid  int p1,local rr
          __GetWindowThreadProcessId p1,varptr(rr)
return  rr
#defcfunc Opto_GetPid2 int p1,local jj,local nn,local rr
   repeat:__FindWindowExA 0,nn,0,0  :nn = stat       :if (nn   ==  0) {        :break}
          __IsWindowVisible nn                       :if (stat ==  0) {continue}
          __GetWindowThreadProcessId nn,varptr(jj)   :if (p1   == jj) {rr = nn :break} :loop
return  rr
#defcfunc Opto_GetFont int p1,array p2,int p3,int p4,local ii,local jj,local ss,local nn,local rr
          sdim  rr,65*p4   :sdim p2
          ii(0) =  $53EC8B55,$00003FBA,$14458B00,$3B08488B,$047C0448,$22EBC033,$8b0840FF,$E1C10848
          ii(8) =  $8D188B06,$5D8B0B0C,$135C8A08,$111C883C,$7DD2854A,$0001B8E6,$5D5B0000,$000010C2
          jj    =  0,0,0,0,0,0,0,0,p3,0,0,0,0,0,0    :nn    =  varptr(rr),p4,0 :ss    =  "",""
          __EnumFontFamiliesExA  hdc,varptr(jj),varptr(ii),    varptr(nn),0
   repeat nn(2)                                      :jj    = (peek(rr,64*cnt) == '@')
          if (jj)          and (p1 ==  0) {continue}
          if (jj    !=  1) and (p1 ==  1) {continue} :memcpy   ss,rr,64,0,64*cnt
          if (ss(1) == ss)                {continue} :rr   +=  ss+"\n"         :ss(1) =  ss
   loop  :split rr,"\n",p2                           :rr    =  length(p2)-1
return  rr
#defcfunc Opto_GetError int p1,int p2,int p3,local ii,local rr
                       sdim rr,512  :__GetLastError  :ii    =  stat
          if (p1    ==  0) {rr = ii}else  {          :ii(1) =  $1200+($FF*((p3>0)^1))
          if (p2    != -1) {ii = p2}:__FormatMessageA ii(1),0,ii,0,varptr(rr),512,0}
return  rr
#defcfunc Opto_ChkBoot str p1,local rr
          __CreateMutexA 0,0,p1:_Mint@Func(3) = stat :__GetLastError :if (stat == 183) {rr = 1}
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _Julius(%1=-1,%2=-1,%3=-1,%4=-1,%5=-1,%6=-1,%7=-1) Opto_Julius(%1,%2,%3,%4,%5,%6,%7)
#define global ctype _Gregorio(%1=2451544.5)                            Opto_Gregorio(%1)
#define global       _Sound(%1=60,%2=30,%3=102,%4=127,%5=0)             Opto_Midi %1,%2,%3,%4,%5
#define global ctype _GetHwnd(%1=_Ures@Func,%2=0,%3=1)                  Opto_GetHwnd(%1,%2,%3)
#define global ctype _GetName(%1=hwnd,%2=0)                             Opto_GetName(%1,%2)
#define global ctype _GetProcess(%1=_Ures@Func,%2=512)                  Opto_GetProcess(%1,%2)
#define global ctype _GetPid(%1=0)                                      Opto_GetPid(%1)
#define global ctype _GetPid2(%1=0)                                     Opto_GetPid2(%1)
#define global ctype _GetFont(%1=0,%2=_Ures@Func,%3=128,%4=512)         Opto_GetFont(%1,%2,%3,%4)
#define global ctype _GetError(%1=0,%2=-1,%3=0)                         Opto_GetError(%1,%2,%3)
#define global ctype _ChkBoot(%1=__UHSP_FUNC__)                         Opto_ChkBoot(%1)
;|============================================================================|
#global
#endif
